HDU 1074 Doing Homework(状压dp+记录路径)

来源:互联网 发布:单片机时钟频率与定时 编辑:程序博客网 时间:2024/06/05 20:15

Doing Homework

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10363 Accepted Submission(s): 4997

Problem Description
Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will reduce his score of the final test, 1 day for 1 point. And as you know, doing homework always takes a long time. So Ignatius wants you to help him to arrange the order of doing homework to minimize the reduced score.

Input
The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case start with a positive integer N(1<=N<=15) which indicate the number of homework. Then N lines follow. Each line contains a string S(the subject’s name, each string will at most has 100 characters) and two integers D(the deadline of the subject), C(how many days will it take Ignatius to finish this subject’s homework).

Note: All the subject names are given in the alphabet increasing order. So you may process the problem much easier.

Output
For each test case, you should output the smallest total reduced score, then give out the order of the subjects, one subject in a line. If there are more than one orders, you should output the alphabet smallest one.

Sample Input
2
3
Computer 3 3
English 20 1
Math 3 2
3
Computer 3 3
English 6 3
Math 6 3

Sample Output
2
Computer
Math
English
3
Computer
English
Math

Hint

In the second test case, both Computer->English->Math and Computer->Math->English leads to reduce 3 points, but the
word “English” appears earlier than the word “Math”, so we choose the first order. That is so-called alphabet order.

题意:有N种作业只能串行写,每个作业有两个参数,死线和完成它需要的时间,每超过死线一天扣一分,问最少扣多少分,并且输出它的作业完成顺序,若有多个输出字典序最小的那个

做法:状态压缩, i状态从只有作业j没做的状态转移过来,预处理一下每个状态下的总花费时间即sum数组
然后dp[i]是从 j没完成的转移过来的,只要枚举转移的状态取最小值就可以了
dp[i] =min(dp[i^(1左移j)]+deducted points)如下图
注意detucted points 不能为负数,所以当计算结果为负数的时候要等于0
这里写图片描述

记录路径:用pre数组记录每个状态新做的作业,再回溯就可以啦
注意按字典序,由于输入的顺序本身就是字典序,那么我们就把 j那一层循环反过来,若有多个方案,最后更新的才会记录下来,所以记录下来的就是字典序最小的方案啦。

原创粉丝点击